#ifndef _XmdExec_h
#define _XmdExec_h

#include <X11/Intrinsic.h>
#include <stdio.h>
#include <sys/types.h>

/* XmdVaPipedExecPath is like XmdPipedExecPath, but it takes in a vararg list to
   use as the "args" array. The vararg list must be terminated by NULL. */
FILE *XmdVaPipedExecPath (const String file, pid_t *child, String mode, ...);

/* XmdPipedExecPath is like popen(), but takes in an explicit command name and
   argument list instead of a shell command. The argument list must be
   terminated by NULL. "file" is searched for in PATH, and it is executed as a
   child process with the specified args. The PID of the child is stored at the
   location of "child".
   
   To correctly close the connection to the child process, first fclose() the
   returned file, and then call waitpid() on the child PID. */
FILE *XmdPipedExecPath (const String file, pid_t *child, String mode, String const argv[]);

#endif
